﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace DemoTIlePanelProblem
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="Form1"/> class.
        /// </summary>
        public Form1()
        {
            InitializeComponent();
        }




        /// <summary>
        /// Shows the drag opeation is allowed
        /// </summary>
        /// <param name="e">The <see cref="System.Windows.Forms.DragEventArgs"/> instance containing the event data.</param>
        private void ShowDragAllowed(DragEventArgs e)
        {
            Panel pnl = new Panel();
            Type myType = pnl.GetType();

            if (e.Data.GetDataPresent(myType))
            {
                e.Effect = DragDropEffects.Move;
            }
            else
            {
                e.Effect = DragDropEffects.None;
            }
        }

        /// <summary>
        /// Handles the TileDragging event of the ultraTilePanel1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="Infragistics.Win.Misc.TileDraggingEventArgs"/> instance containing the event data.</param>
        private void ultraTilePanel1_TileDragging(object sender, Infragistics.Win.Misc.TileDraggingEventArgs e)
        {
            Panel pnl = e.Tile.Control as Panel;
            DataObject obj = new DataObject();
            obj.SetData(pnl);
            e.Tile.DoDragDrop(obj, DragDropEffects.Move);
        }

        /// <summary>
        /// Handles the DragEnter event of the panel1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.DragEventArgs"/> instance containing the event data.</param>
        private void panel1_DragEnter(object sender, DragEventArgs e)
        {
            ShowDragAllowed(e);
        }

        /// <summary>
        /// Handles the DragOver event of the panel1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.DragEventArgs"/> instance containing the event data.</param>
        private void panel1_DragOver(object sender, DragEventArgs e)
        {
            ShowDragAllowed(e);
        }

        /// <summary>
        /// Handles the DragDrop event of the panel1 control.
        /// </summary>
        /// <param name="sender">The source of the event.</param>
        /// <param name="e">The <see cref="System.Windows.Forms.DragEventArgs"/> instance containing the event data.</param>
        private void panel1_DragDrop(object sender, DragEventArgs e)
        {
            Panel pnl = (Panel)e.Data.GetData(typeof(Panel));
            panel1.BackColor = pnl.BackColor;
        }
    }
}
